#include <stdio.h>
#include <stdlib.h>
#include <dlfcn.h>
#include "interface.h"

static plugin_t *first_plugin = NULL;

void register_with_main(plugin_t *plugin) {
  plugin->next = first_plugin;
  first_plugin = plugin;
}

void load_one(char *name) {
  void *handle = dlopen(name, RTLD_LAZY);
  if (handle == NULL) {
    fprintf(stderr, "Failed to load %s: %s\n", name, dlerror());
  }
  free(name);
}

char *assemble_filename(char *filename) {
  int size = snprintf(NULL, 0, "%s/%s", PWD, filename);
  char *ret = malloc(size + 1);
  snprintf(ret, size + 1, "%s/%s", PWD, filename);
  return ret;
}

int main(int argc, char **argv) {
  plugin_t *iter = NULL;
  system("cp shared-rename.so shared.so");
  load_one(assemble_filename("plugin1.so"));
  system("cp shared-rename.so shared.so");
  load_one(assemble_filename("plugin2.so"));
  for (iter = first_plugin; iter != NULL; iter = iter->next) {
    iter->callback();
  }
}
